//--------------------------------------------------------------------
// YUY2YC48̐FԁiFjsv̏ꍇ̕ϊ
//
// F̕Ԃɂ
// YUY2FF̕ԂȂi2sNZ𓯂Fɂj
// oYUY2FFL2sNZŕςďo
//
// YUV to YC48 ̕ϊi:BT.601 :BT.709j
// y  = (4788*(Y-16) +  490*(U-128) +  939*(V-128) + 128) >> 8;
// cb = (              4633*(U-128) -  519*(V-128) + 128) >> 8;
// cr = (              -343*(U-128) + 4602*(V-128) + 128) >> 8;
//
// YUV to YC48 ̕ϊi:BT.709 :BT.601j
// y  = (4788*(Y-16) -  571*(U-128) - 1019*(V-128) + 128) >> 8;
// cb = (              4769*(U-128) +  537*(V-128) + 128) >> 8;
// cr = (               355*(U-128) + 4801*(V-128) + 128) >> 8;
//
// YC48 to YUV ̕ϊi:BT.601 o:BT.709j
// Y = ( (438*y - 53*cb -  94*cr + 4096) >> 13 ) + 16;
// U = ( (       456*cb +  51*cr + 4096) >> 13 ) + 128;
// V = ( (        33*cb + 459*cr + 4096) >> 13 ) + 128;
// 
// YC48 to YUV ̕ϊi:BT.709 o:BT.709j
// Y = ( (438*y + 46*cb +  87*cr + 4096) >> 13 ) + 16;
// U = ( (       443*cb -  50*cr + 4096) >> 13 ) + 128;
// V = ( (       -33*cb + 440*cr + 4096) >> 13 ) + 128;
//
//--------------------------------------------------------------------
#include <stdint.h>
#include <windows.h>
#include <mmintrin.h>
#include <xmmintrin.h>
#include <emmintrin.h>
#include "color.h"

//---------------------------------------------------------------------
// short^232bitɂ
//---------------------------------------------------------------------
#define MK_INT( A, B ) ( (int)(unsigned short)A | ((int)B << 16) )

//---------------------------------------------------------------------
// _mm_setr_epi16  _mm_insert_epi16 ōČ
//---------------------------------------------------------------------
#define MY_SETR_EPI16( w0, w1, w2, w3, w4, w5, w6, w7 ) _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_cvtsi32_si128( w0 ), w1, 1 ), w2, 2 ), w3, 3 ), w4, 4 ), w5, 5 ), w6, 6 ), w7, 7 )

/*
inline __m128i MY_SETR_EPI16( const short &w0, const short &w1, const short &w2, const short &w3, const short &w4, const short &w5, const short &w6, const short &w7 )
{
    __m128i t = _mm_cvtsi32_si128( w0 );
    t = _mm_insert_epi16( t, w1, 1 );
    t = _mm_insert_epi16( t, w2, 2 );
    t = _mm_insert_epi16( t, w3, 3 );
    t = _mm_insert_epi16( t, w4, 4 );
    t = _mm_insert_epi16( t, w5, 5 );
    t = _mm_insert_epi16( t, w6, 6 );
    return _mm_insert_epi16( t, w7, 7 );
}
*/

//---------------------------------------------------------------------
// 0`255ɖOa
//---------------------------------------------------------------------
inline int satura8bit( const int a )
{
    if( a <   0 ) return 0;
    if( a > 255 ) return 255;
    return a;
}

//---------------------------------------------------------------------
// [Xbh] YUY2 -> YC48iƓ͂̐FԂقȂꍇj
//
// convert_mode
// 0: BT.601 BT.709
// 1: BT.709 BT.601
//---------------------------------------------------------------------
void __attribute__((force_align_arg_pointer)) thread_pixel2yc_yuy2_convert( int thread_id, int thread_num, void *param1, void *param2 )
{
    // l[
    const COLOR_PROC_INFO *cpip  = (COLOR_PROC_INFO *)param1;
    const int convert_mode = *(int *)param2;

    // [JϐɃRs[
    const int h         = cpip->h;
    const int w         = cpip->w;
    const int line_size = cpip->line_size;

	// ̂ŁAXbh𔼕ɂė̏Ƀ\[X
	if( thread_id < 0 || thread_num <= 0 ) return; // 肦ȂlȂ̂
	if( thread_id & 0x1 ) return; // eîݎcj
	thread_id = thread_id >> 1;
	thread_num = (thread_num + 1 ) >> 1;

    // Xbhc̃TCY葽璲
    if( thread_num > h ) thread_num = h;
    if( thread_id >= thread_num ) return;

    // Xbh̉摜郉CvZ
    const int y_start = (h *  thread_id     ) / thread_num;
    const int y_end   = (h * (thread_id + 1)) / thread_num;

    // ϐvZ
    const int pixel_line_size = ((w+1)/2*4);
    PIXEL_YC *ycp = cpip->ycp;
    const unsigned char *pixelp  = (unsigned char *)cpip->pixelp;

    // :BT.601 O:BT.709
    // yy = ( 4788*Y+  490*U +  939*V - 259392) >> 8
    // cb = (         4633*U -  519*V - 526464) >> 8
    // cr = (         -343*U + 4602*V - 545024) >> 8
    //
    // ό`
    // y0 = ( (  490*U +  939*V ) + (  Y0* 4788 + -16*16212 ) ) >> 8
    // cb = ( ( 4633*U + -519*V ) + ( -16*16452 + -16*16452 ) ) >> 8
    // y1 = ( (  490*U +  939*V ) + (  Y1* 4788 + -16*16220 ) ) >> 8
    // cr = ( ( -343*U + 4602*V ) + ( -16*17032 + -16*17032 ) ) >> 8
    //                                      
    //             coe0            coe2   
    //                                         coe1 
    //
    // :BT.709 O:BT.601
    // yy = ( 4788*Y -  571*U - 1019*V + 127040) >> 8
    // cb = (          4769*U +  537*V - 679168) >> 8
    // cr = (           355*U + 4801*V - 659968) >> 8
    //
    // ό`
    // y0 = ( ( -571*U - 1019*V ) + (  Y0* 4788 + -16*-7940 ) ) >> 8
    // cb = ( ( 4769*U +  537*V ) + ( -16*21224 + -16*21224 ) ) >> 8
    // y1 = ( ( -571*U - 1019*V ) + (  Y1* 4788 + -16*-7940 ) ) >> 8
    // cr = ( (  355*U + 4801*V ) + ( -16*20624 + -16*20624 ) ) >> 8
    //                                      
    //             coe0            coe2   
    //                                         coe1 
    // convert_mode
    // 0: BT.601 BT.709
    // 1: BT.709 BT.601
    const __m128i coe0 = (convert_mode == 0)
                        ? _mm_setr_epi16(  490,   939, 4633, -519,  490,   939, -343, 4602 )
                        : _mm_setr_epi16( -571, -1019, 4769,  537, -571, -1019,  355, 4801 );
    const __m128i coe1 = (convert_mode == 0)
                        ? _mm_setr_epi16(  4788, 16212, 16452, 16452,  4788, 16220, 17032, 17032 )
                        : _mm_setr_epi16(  4788, -7940, 21224, 21224,  4788, -7940, 20624, 20624 );
    const __m128i coe2 = _mm_setr_epi16( -16, -16, -16, -16, -16, -16, -16, -16 );

    #define MY_SET_YUY2YC_UV_( U, V ) _mm_shuffle_epi32( _mm_insert_epi16( _mm_cvtsi32_si128( U ), V, 1 ), _MM_SHUFFLE( 0, 0, 0, 0 ) )
    #define MY_SET_YUY2YC_Y_( Y0, Y1 ) _mm_insert_epi16( _mm_insert_epi16( coe2, Y0, 0 ), Y1, 4 )
    #define MY_CALC_YUY2YC_( Y0, U, Y1, V ) _mm_srai_epi32( _mm_add_epi32( _mm_madd_epi16( MY_SET_YUY2YC_Y_( Y0, Y1 ), coe1 ), _mm_madd_epi16( MY_SET_YUY2YC_UV_( U, V ), coe0 ) ), 8 )

    for( int y = y_start; y < y_end; y++ )
    {
        PIXEL_YC *__restrict__ ycp2 = (PIXEL_YC *)( (BYTE *)ycp + y * line_size );
        const unsigned char *__restrict__ pixelp2 = (unsigned char *)pixelp + y * pixel_line_size;

        int x = 0;

        // o͑̃|C^16byteACgɑB
        // 蔲̂߁ApaddingŒł4byteɑĂ  xȏ̉KvB
        intptr_t padding = (intptr_t)ycp2 & 0xF;
        if( w > 31 && !(padding & 0x3) )
        {
            padding >>= 1; // ̂ɕKvȃsNZ

            _mm_prefetch( (BYTE *)pixelp2 + pixel_line_size, _MM_HINT_NTA ); // ̃CvtFb`

            // 1pbN2sNZ
            for( ; x < padding; x += 2 )
            {
                __m128i xmm0 = MY_CALC_YUY2YC_( pixelp2[0], pixelp2[1], pixelp2[2], pixelp2[3] );
                _mm_stream_si32( (int *)ycp2 + 0, MK_INT( _mm_extract_epi16( xmm0, 0 ), _mm_extract_epi16( xmm0, 2 ) ) );
                _mm_stream_si32( (int *)ycp2 + 1, MK_INT( _mm_extract_epi16( xmm0, 6 ), _mm_extract_epi16( xmm0, 4 ) ) );
                _mm_stream_si32( (int *)ycp2 + 2, MK_INT( _mm_extract_epi16( xmm0, 2 ), _mm_extract_epi16( xmm0, 6 ) ) );
                ycp2 += 2;
                pixelp2 += 4;
            }
            // ACgĂ
            // 4pbN8sNZ
            for( ; x < w - 6; x += 8 )
            {
                _mm_prefetch( (BYTE *)pixelp2 + pixel_line_size, _MM_HINT_NTA ); // ̃CvtFb`

                __m128i xmm0 = _mm_packs_epi32(
                    MY_CALC_YUY2YC_( pixelp2[0], pixelp2[1], pixelp2[2], pixelp2[3] ),
                    MY_CALC_YUY2YC_( pixelp2[4], pixelp2[5], pixelp2[6], pixelp2[7] )
                );
                __m128i xmm1 = _mm_packs_epi32(
                    MY_CALC_YUY2YC_( pixelp2[ 8], pixelp2[ 9], pixelp2[10], pixelp2[11] ),
                    MY_CALC_YUY2YC_( pixelp2[12], pixelp2[13], pixelp2[14], pixelp2[15] )
                );

                __m128i out0 = _mm_shufflelo_epi16( xmm0, _MM_SHUFFLE( 3, 1, 2, 0 ) );
                out0 = _mm_shuffle_epi32( out0, _MM_SHUFFLE( 2, 1, 1, 0 ) );
                out0 = _mm_shufflelo_epi16( out0, _MM_SHUFFLE( 1, 3, 2, 0 ) );
                _mm_stream_si128( (__m128i *)ycp2 + 0, out0 ); // o

                __m128i out1 = _mm_unpacklo_epi64( _mm_srli_si128( xmm0, 8 ), xmm1 );
                out1 = _mm_shufflelo_epi16( out1, _MM_SHUFFLE( 3, 1, 2, 3 ) );
                out1 = _mm_shufflehi_epi16( out1, _MM_SHUFFLE( 2, 3, 1, 0 ) );
                _mm_stream_si128( (__m128i *)ycp2 + 1, out1 ); // o

                __m128i out2 = _mm_shufflelo_epi16( xmm1, _MM_SHUFFLE( 3, 2, 3, 1 ) );
                out2 = _mm_shuffle_epi32( out2, _MM_SHUFFLE( 3, 2, 2, 0 ) );
                out2 = _mm_shufflehi_epi16( out2, _MM_SHUFFLE( 3, 1, 2, 3 ) );
                _mm_stream_si128( (__m128i *)ycp2 + 2, out2 ); // o

                ycp2 += 8;
                pixelp2 += 4*4;
            }
            // 1pbN2sNZ
            for( ; x < w; x += 2 )
            {
                __m128i xmm0 = MY_CALC_YUY2YC_( pixelp2[0], pixelp2[1], pixelp2[2], pixelp2[3] );
                _mm_stream_si32( (int *)ycp2 + 0, MK_INT( _mm_extract_epi16( xmm0, 0 ), _mm_extract_epi16( xmm0, 2 ) ) );
                _mm_stream_si32( (int *)ycp2 + 1, MK_INT( _mm_extract_epi16( xmm0, 6 ), _mm_extract_epi16( xmm0, 4 ) ) );
                _mm_stream_si32( (int *)ycp2 + 2, MK_INT( _mm_extract_epi16( xmm0, 2 ), _mm_extract_epi16( xmm0, 6 ) ) );
                ycp2 += 2;
                pixelp2 += 4;
            }
        }
        else
        {
            // ACgĂȂ
            // 4pbN8sNZ
            for( ; x < w - 6; x += 8 )
            {
                _mm_prefetch( (BYTE *)pixelp2 + pixel_line_size, _MM_HINT_NTA ); // ̃CvtFb`

                __m128i xmm0 = _mm_packs_epi32(
                    MY_CALC_YUY2YC_( pixelp2[0], pixelp2[1], pixelp2[2], pixelp2[3] ),
                    MY_CALC_YUY2YC_( pixelp2[4], pixelp2[5], pixelp2[6], pixelp2[7] )
                );

                __m128i xmm1 = _mm_packs_epi32(
                    MY_CALC_YUY2YC_( pixelp2[ 8], pixelp2[ 9], pixelp2[10], pixelp2[11] ),
                    MY_CALC_YUY2YC_( pixelp2[12], pixelp2[13], pixelp2[14], pixelp2[15] )
                );

                __m128i out0 = _mm_shufflelo_epi16( xmm0, _MM_SHUFFLE( 3, 1, 2, 0 ) );
                out0 = _mm_shuffle_epi32( out0, _MM_SHUFFLE( 2, 1, 1, 0 ) );
                out0 = _mm_shufflelo_epi16( out0, _MM_SHUFFLE( 1, 3, 2, 0 ) );
                _mm_storeu_si128( (__m128i *)ycp2 + 0, out0 ); // o

                __m128i out1 = _mm_unpacklo_epi64( _mm_srli_si128( xmm0, 8 ), xmm1 );
                out1 = _mm_shufflelo_epi16( out1, _MM_SHUFFLE( 3, 1, 2, 3 ) );
                out1 = _mm_shufflehi_epi16( out1, _MM_SHUFFLE( 2, 3, 1, 0 ) );
                _mm_storeu_si128( (__m128i *)ycp2 + 1, out1 ); // o

                __m128i out2 = _mm_shufflelo_epi16( xmm1, _MM_SHUFFLE( 3, 2, 3, 1 ) );
                out2 = _mm_shuffle_epi32( out2, _MM_SHUFFLE( 3, 2, 2, 0 ) );
                out2 = _mm_shufflehi_epi16( out2, _MM_SHUFFLE( 3, 1, 2, 3 ) );
                _mm_storeu_si128( (__m128i *)ycp2 + 2, out2 ); // o

                ycp2 += 8;
                pixelp2 += 4*4;
            }
            // 2sNZ1pbN
            for( ; x < w; x += 2 )
            {
                __m128i xmm0 = MY_CALC_YUY2YC_( pixelp2[0], pixelp2[1], pixelp2[2], pixelp2[3] );
                ycp2[0].y  = _mm_extract_epi16( xmm0, 0 );
                ycp2[0].cb = _mm_extract_epi16( xmm0, 2 );
                ycp2[0].cr = _mm_extract_epi16( xmm0, 6 );
                ycp2[1].y  = _mm_extract_epi16( xmm0, 4 );
                ycp2[1].cb = _mm_extract_epi16( xmm0, 2 );
                ycp2[1].cr = _mm_extract_epi16( xmm0, 6 );
                ycp2 += 2;
                pixelp2 += 4;
            }
        }
    }
}

//---------------------------------------------------------------------
// [Xbh] YC48 -> YUY2iƏo͂̐FԂقȂꍇj
//
// convert_mode
// 0: BT.601 oBT.709
// 1: BT.709 oBT.601
//---------------------------------------------------------------------
void __attribute__((force_align_arg_pointer)) thread_yc2pixel_yuy2_convert( int thread_id, int thread_num, void *param1, void *param2 )
{
    // l[
    const COLOR_PROC_INFO *cpip  = (COLOR_PROC_INFO *)param1;
    const int convert_mode = *(int *)param2;

    // [JϐɃRs[
    const int line_size = cpip->line_size;
    const int w         = cpip->w;
    const int h         = cpip->h;
    PIXEL_YC *ycp       = cpip->ycp;
    DWORD *pixelp       = (DWORD *)cpip->pixelp;

	// ̂ŁAXbh𔼕ɂė̏Ƀ\[X
	if( thread_id < 0 || thread_num <= 0 ) return; // 肦ȂlȂ̂
	if( thread_id & 0x1 ) return; // eîݎcj
	thread_id = thread_id >> 1;
	thread_num = (thread_num + 1 ) >> 1;

    // Xbhc̃TCY葽璲
    if( thread_num > h ) thread_num = h;
    if( thread_id >= thread_num ) return;

    // Xbh̉摜郉CvZ
    const int y_start = (h *  thread_id     ) / thread_num;
    const int y_end   = (h * (thread_id + 1)) / thread_num;

    // W萔
    const int pixel_line_size = ((w+1)/2*4);

    // YC48 to YUV ̕ϊi:BT.601 O:BT.709j
    // Y0 = ( (438*y0 - 53*cb0       -  94*cr0       + 4096) >> 13 ) + 16;
    // U  = ( (        456*(cb0+cb1) +  51*(cr0+cr1) + 8192) >> 14 ) + 128;
    // Y1 = ( (438*y1 - 53*cb1       -  94*cr1       + 4096) >> 13 ) + 16;
    // V  = ( (         33*(cb0+cb1) + 459*(cr0+cr1) + 8192) >> 14 ) + 128;
    //
    // ό`
    // Y0 = ( (876*y0  +   0*y0 ) + (-106*cb0 + -188*cr0) + 8192+ 16*16384 ) >> 14;
    // U  = ( (456*cb0 +  51*cr0) + ( 456*cb1 +   51*cr1) + 8192+128*16384 ) >> 14;
    // Y1 = ( (876*y1  +   0*y1 ) + (-106*cb1 + -188*cr1) + 8192+ 16*16384 ) >> 14;
    // V  = ( ( 33*cb1 + 459*cr1) + (  33*cb0 +  459*cr0) + 8192+128*16384 ) >> 14;
    //                                              
    //             coe0             coe1           coeA
    //
    // YC48 to YUV ̕ϊi:BT.709 O:BT.709j
    // Y0 = ( (438*y0 + 46*cb0       +  87*cr0       + 4096) >> 13 ) + 16;
    // U  = ( (        443*(cb0+cr1) -  50*(cb0+cr1) + 8192) >> 14 ) + 128;
    // Y1 = ( (438*y1 + 46*cb0       +  87*cr0       + 4096) >> 13 ) + 16;
    // V  = ( (        -33*(cb0+cr1) + 440*(cb0+cr1) + 8192) >> 14 ) + 128;
    //
    // ό`
    // Y0 = ( (876*y0  +   0*y0 ) + ( 92*cb0 + 174*cr0) + 8192+ 16*16384 ) >> 14;
    // U  = ( (443*cb0 + -50*cr0) + (443*cb1 + -50*cr1) + 8192+128*16384 ) >> 14;
    // Y1 = ( (876*y1  +   0*y1 ) + ( 92*cb1 + 174*cr1) + 8192+ 16*16384 ) >> 14;
    // V  = ( (-33*cb1 + 440*cr1) + (-33*cb0 + 440*cr0) + 8192+128*16384 ) >> 14;
    //                                              
    //             coe0             coe1           coeA
    //
    // convert_mode
    // 0: BT.601 oBT.709
    // 1: BT.709 oBT.601
    const __m128i coe0 = (convert_mode == 0)
                        ? _mm_setr_epi16( 876,   0, 456,  51, 876,   0,  33, 459 )
                        : _mm_setr_epi16( 876,   0, 443, -50, 876,   0, -33, 440 );
    const __m128i coe1 = (convert_mode == 0)
                        ? _mm_setr_epi16(-106,-188, 456,  51,-106,-188,  33, 459 )
                        : _mm_setr_epi16(  92, 174, 443, -50,  92, 174, -33, 440 );
    const __m128i coeA = _mm_setr_epi32( 8192+ 16*16384, 8192+128*16384, 8192+ 16*16384, 8192+128*16384 );

    for( int y = y_start; y < y_end; y++ )
    {
        const PIXEL_YC *__restrict__ ycp2 = (PIXEL_YC *)( (BYTE *)ycp + y * line_size );
        unsigned int *__restrict__ pixelp2 = (unsigned int *)( (BYTE *)pixelp + y * pixel_line_size );

        int x = 0;

        // o͑̃|C^16byteACgɑB
        // 蔲̂߁ApaddingŒł4byteɑĂ  xȏ̉KvB
        intptr_t padding = ( 0 - (intptr_t)pixelp2 ) & 0xF;
        if( w > 31 && !(padding & 0x3) )
        {
            padding >>= 1; // ̂ɕKvȃsNZ

            _mm_prefetch( (BYTE *)ycp2 + line_size, _MM_HINT_NTA ); // ̃CvtFb`

            // 
            for( ; x < padding; x += 2 )
            {
                __m128i xmm0 = _mm_setzero_si128();
                xmm0 = _mm_insert_epi16( xmm0, ycp2[0].y,  0 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[0].cb, 2 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[0].cr, 3 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[1].y,  4 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[1].cb, 6 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[1].cr, 7 );
                __m128i xmm1 = _mm_shuffle_epi32( xmm0, _MM_SHUFFLE( 1, 3, 3, 1 ) );
                xmm0 = _mm_madd_epi16( xmm0, coe0 );
                xmm1 = _mm_madd_epi16( xmm1, coe1 );
                xmm0 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( xmm0, xmm1 ), coeA ), 14 );
                xmm0 = _mm_packs_epi32( xmm0, xmm0 );
                xmm0 = _mm_packus_epi16( xmm0, xmm0 );
                _mm_stream_si32( (int *)pixelp2, _mm_cvtsi128_si32( xmm0 ) );
                ycp2 += 2; 
                pixelp2++;
            }
            // ACgĂ
            // 8sNZ4pbN
            for( ; x < w - 6; x += 8 )
            {
                _mm_prefetch( (BYTE *)ycp2 + line_size, _MM_HINT_NTA ); // ̃CvtFb`

                __m128i in0 = _mm_loadu_si128( (__m128i *)ycp2     );
                __m128i in1 = _mm_loadu_si128( (__m128i *)ycp2 + 1 );
                __m128i in2 = _mm_loadu_si128( (__m128i *)ycp2 + 2 );

                __m128i t0 = _mm_shuffle_epi32( in0, _MM_SHUFFLE( 1, 2, 1, 0 ) );
                t0 = _mm_shufflelo_epi16( t0, _MM_SHUFFLE( 2, 1, 1, 0 ) );
                t0 = _mm_shufflehi_epi16( t0, _MM_SHUFFLE( 1, 0, 1, 3 ) );
                __m128i t1 = _mm_shuffle_epi32( t0, _MM_SHUFFLE( 1, 3, 3, 1 ) );
                t0 = _mm_madd_epi16( t0, coe0 );
                t1 = _mm_madd_epi16( t1, coe1 );
                t0 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( t0, t1 ), coeA ), 14 );

                __m128i t2 = _mm_unpacklo_epi64( _mm_srli_si128( in0, 8 ), in1 );
                t2 = _mm_shuffle_epi32( t2, _MM_SHUFFLE( 3, 2, 2, 1 ) );
                t2 = _mm_shufflelo_epi16( t2, _MM_SHUFFLE( 2, 1, 1, 0 ) );
                t2 = _mm_shufflehi_epi16( t2, _MM_SHUFFLE( 3, 2, 1, 1 ) );
                __m128i t3 = _mm_shuffle_epi32( t2, _MM_SHUFFLE( 1, 3, 3, 1 ) );
                t2 = _mm_madd_epi16( t2, coe0 );
                t3 = _mm_madd_epi16( t3, coe1 );
                t2 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( t2, t3 ), coeA ), 14 );

                __m128i xmm0 = _mm_packs_epi32( t0, t2 );

                __m128i t4 = _mm_unpacklo_epi64( _mm_srli_si128( in1, 8 ), in2 );
                t4 = _mm_shuffle_epi32( t4, _MM_SHUFFLE( 1, 2, 1, 0 ) );
                t4 = _mm_shufflelo_epi16( t4, _MM_SHUFFLE( 2, 1, 1, 0 ) );
                t4 = _mm_shufflehi_epi16( t4, _MM_SHUFFLE( 1, 0, 1, 3 ) );
                __m128i t5 = _mm_shuffle_epi32( t4, _MM_SHUFFLE( 1, 3, 3, 1 ) );
                t4 = _mm_madd_epi16( t4, coe0 );
                t5 = _mm_madd_epi16( t5, coe1 );

                __m128i t6 = _mm_shuffle_epi32( in2, _MM_SHUFFLE( 3, 2, 1, 2 ) );
                t6 = _mm_shufflelo_epi16( t6, _MM_SHUFFLE( 0, 3, 1, 2 ) );
                t6 = _mm_shufflehi_epi16( t6, _MM_SHUFFLE( 3, 2, 1, 1 ) );
                __m128i t7 = _mm_shuffle_epi32( t6, _MM_SHUFFLE( 1, 3, 3, 1 ) );
                t6 = _mm_madd_epi16( t6, coe0 );
                t7 = _mm_madd_epi16( t7, coe1 );

                t4 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( t4, t5 ), coeA ), 14 );
                t6 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( t6, t7 ), coeA ), 14 );
                __m128i xmm1 = _mm_packs_epi32( t4, t6 );

                _mm_stream_si128( (__m128i *)pixelp2, _mm_packus_epi16( xmm0, xmm1 ) ); // o

                ycp2 += 8;
                pixelp2 += 4;
            }
            // c2sNZ1pbN
            for( ; x < w; x += 2 )
            {
                __m128i xmm0 = _mm_setzero_si128();
                xmm0 = _mm_insert_epi16( xmm0, ycp2[0].y,  0 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[0].cb, 2 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[0].cr, 3 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[1].y,  4 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[1].cb, 6 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[1].cr, 7 );
                __m128i xmm1 = _mm_shuffle_epi32( xmm0, _MM_SHUFFLE( 1, 3, 3, 1 ) );
                xmm0 = _mm_madd_epi16( xmm0, coe0 );
                xmm1 = _mm_madd_epi16( xmm1, coe1 );
                xmm0 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( xmm0, xmm1 ), coeA ), 14 );
                xmm0 = _mm_packs_epi32( xmm0, xmm0 );
                xmm0 = _mm_packus_epi16( xmm0, xmm0 );
                _mm_stream_si32( (int *)pixelp2, _mm_cvtsi128_si32( xmm0 ) );
                ycp2 += 2; 
                pixelp2++;
            }
        }
        else
        {
            // ACgĂȂ
            // i stream o͂uj
            // 8sNZ4pbN
            for( ; x < w - 6; x += 8 )
            {
                _mm_prefetch( (BYTE *)ycp2 + line_size, _MM_HINT_NTA ); // ̃CvtFb`

                __m128i in0 = _mm_loadu_si128( (__m128i *)ycp2     );
                __m128i in1 = _mm_loadu_si128( (__m128i *)ycp2 + 1 );
                __m128i in2 = _mm_loadu_si128( (__m128i *)ycp2 + 2 );

                __m128i t0 = _mm_shuffle_epi32( in0, _MM_SHUFFLE( 1, 2, 1, 0 ) );
                t0 = _mm_shufflelo_epi16( t0, _MM_SHUFFLE( 2, 1, 1, 0 ) );
                t0 = _mm_shufflehi_epi16( t0, _MM_SHUFFLE( 1, 0, 1, 3 ) );
                __m128i t1 = _mm_shuffle_epi32( t0, _MM_SHUFFLE( 1, 3, 3, 1 ) );
                t0 = _mm_madd_epi16( t0, coe0 );
                t1 = _mm_madd_epi16( t1, coe1 );
                t0 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( t0, t1 ), coeA ), 14 );

                __m128i t2 = _mm_unpacklo_epi64( _mm_srli_si128( in0, 8 ), in1 );
                t2 = _mm_shuffle_epi32( t2, _MM_SHUFFLE( 3, 2, 2, 1 ) );
                t2 = _mm_shufflelo_epi16( t2, _MM_SHUFFLE( 2, 1, 1, 0 ) );
                t2 = _mm_shufflehi_epi16( t2, _MM_SHUFFLE( 3, 2, 1, 1 ) );
                __m128i t3 = _mm_shuffle_epi32( t2, _MM_SHUFFLE( 1, 3, 3, 1 ) );
                t2 = _mm_madd_epi16( t2, coe0 );
                t3 = _mm_madd_epi16( t3, coe1 );
                t2 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( t2, t3 ), coeA ), 14 );

                __m128i xmm0 = _mm_packs_epi32( t0, t2 );

                __m128i t4 = _mm_unpacklo_epi64( _mm_srli_si128( in1, 8 ), in2 );
                t4 = _mm_shuffle_epi32( t4, _MM_SHUFFLE( 1, 2, 1, 0 ) );
                t4 = _mm_shufflelo_epi16( t4, _MM_SHUFFLE( 2, 1, 1, 0 ) );
                t4 = _mm_shufflehi_epi16( t4, _MM_SHUFFLE( 1, 0, 1, 3 ) );
                __m128i t5 = _mm_shuffle_epi32( t4, _MM_SHUFFLE( 1, 3, 3, 1 ) );
                t4 = _mm_madd_epi16( t4, coe0 );
                t5 = _mm_madd_epi16( t5, coe1 );
                t4 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( t4, t5 ), coeA ), 14 );

                __m128i t6 = _mm_shuffle_epi32( in2, _MM_SHUFFLE( 3, 2, 1, 2 ) );
                t6 = _mm_shufflelo_epi16( t6, _MM_SHUFFLE( 0, 3, 1, 2 ) );
                t6 = _mm_shufflehi_epi16( t6, _MM_SHUFFLE( 3, 2, 1, 1 ) );
                __m128i t7 = _mm_shuffle_epi32( t6, _MM_SHUFFLE( 1, 3, 3, 1 ) );
                t6 = _mm_madd_epi16( t6, coe0 );
                t7 = _mm_madd_epi16( t7, coe1 );
                t6 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( t6, t7 ), coeA ), 14 );

                __m128i xmm1 = _mm_packs_epi32( t4, t6 );

                _mm_storeu_si128( (__m128i *)pixelp2, _mm_packus_epi16( xmm0, xmm1 ) ); // o

                ycp2 += 8;
                pixelp2 += 4;
            }
            // c2sNZ1pbN
            for( ; x < w; x += 2 )
            {
                __m128i xmm0 = _mm_setzero_si128();
                xmm0 = _mm_insert_epi16( xmm0, ycp2[0].y,  0 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[0].cb, 2 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[0].cr, 3 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[1].y,  4 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[1].cb, 6 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[1].cr, 7 );
                __m128i xmm1 = _mm_shuffle_epi32( xmm0, _MM_SHUFFLE( 1, 3, 3, 1 ) );
                xmm0 = _mm_madd_epi16( xmm0, coe0 );
                xmm1 = _mm_madd_epi16( xmm1, coe1 );
                xmm0 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( xmm0, xmm1 ), coeA ), 14 );
                xmm0 = _mm_packs_epi32( xmm0, xmm0 );
                xmm0 = _mm_packus_epi16( xmm0, xmm0 );
                *(int *)pixelp2 = _mm_cvtsi128_si32( xmm0 );
                ycp2 += 2; 
                pixelp2++;
            }
        }
    }
}

