//--------------------------------------------------------------------
// RGBp[g
//
// RGB to YC48 ̕ϊiAviUtlBT.601̏ꍇj
// y  = ( 19666*R + 38595*G +  7532*B + 2048) >> 12;
// cb = (-11105*R - 21792*G + 32897*B + 2048) >> 12;
// cr = ( 32897*R - 27525*G -  5372*B + 2048) >> 12;
//
// RGB to YC48 ̕ϊiAviUtlBT.709̏ꍇj
// y  = ( 13987*R + 47055*G +  4750*B + 2048) >> 12;
// cb = ( -7539*R - 25359*G + 32896*B + 2048) >> 12;
// cr = ( 32896*R - 29881*G -  3017*B + 2048) >> 12;
//
// YC48 to RGB ̕ϊiAviUtlBT.601̏ꍇj
// R = ( 255*y           + 358*cr + 2048) >> 12;
// G = ( 255*y -  88*cb -  182*cr + 2048) >> 12;
// B = ( 255*y + 452*cb           + 2048) >> 12;
// 
// YC48 to RGB ̕ϊiAviUtlBT.709̏ꍇj
// R = ( 255*y           + 401*cr + 2048) >> 12;
// G = ( 255*y -  48*cb -  120*cr + 2048) >> 12;
// B = ( 255*y + 473*cb           + 2048) >> 12;
//--------------------------------------------------------------------
#include <stdint.h>
#include <windows.h>
#include <mmintrin.h>
#include <xmmintrin.h>
#include <emmintrin.h>
#include "color.h"

//---------------------------------------------------------------------
// short^232bitɂ
//---------------------------------------------------------------------
#define MK_INT( A, B ) ( (int)(unsigned short)A | ((int)B << 16) )

//---------------------------------------------------------------------
// _mm_setr_epi16  _mm_insert_epi16 ōČ
//---------------------------------------------------------------------
#define MY_SETR_EPI16( w0, w1, w2, w3, w4, w5, w6, w7 ) _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_cvtsi32_si128( w0 ), w1, 1 ), w2, 2 ), w3, 3 ), w4, 4 ), w5, 5 ), w6, 6 ), w7, 7 )

/*
inline __m128i MY_SETR_EPI16( const short &w0, const short &w1, const short &w2, const short &w3, const short &w4, const short &w5, const short &w6, const short &w7 )
{
    __m128i t = _mm_cvtsi32_si128( w0 );
    t = _mm_insert_epi16( t, w1, 1 );
    t = _mm_insert_epi16( t, w2, 2 );
    t = _mm_insert_epi16( t, w3, 3 );
    t = _mm_insert_epi16( t, w4, 4 );
    t = _mm_insert_epi16( t, w5, 5 );
    t = _mm_insert_epi16( t, w6, 6 );
    return _mm_insert_epi16( t, w7, 7 );
}
*/

//---------------------------------------------------------------------
// 0`255ɖOa
//---------------------------------------------------------------------
inline int satura8bit( const int a )
{
    if( a <   0 ) return 0;
    if( a > 255 ) return 255;
    return a;
}

//---------------------------------------------------------------------
// [Xbh] RGB24 -> YC48
// convert_mode̒lɂē`ς
// 0:BT.601
// 1:BT.709
//---------------------------------------------------------------------
void __attribute__((force_align_arg_pointer)) thread_pixel2yc_rgb24( int thread_id, int thread_num, void *param1, void *param2 )
{
    // l[
    const COLOR_PROC_INFO *cpip  = (COLOR_PROC_INFO *)param1;
    const int convert_mode = *(int *)param2; //  0:BT.601  1:BT.709

    // [JϐɃRs[
    const int h         = cpip->h;
    const int w         = cpip->w;
    const int line_size = cpip->line_size;

    // Xbhc̃TCY葽璲
    if( thread_num > h ) thread_num = h;
    if( thread_id >= thread_num ) return;

    // Xbh̉摜郉CvZ
    const int y_start = (h *  thread_id     ) / thread_num;
    const int y_end   = (h * (thread_id + 1)) / thread_num;

    // ϐvZ
    const int pixel_line_size = (w*3+3)&(~3L);
    PIXEL_YC *ycp = cpip->ycp;
    unsigned char *pixelp  = (unsigned char *)cpip->pixelp;


    // BT.601̏ꍇ
    // ̕ϊ
    // Y = ( 19666*R + 38595*G +  7532*B + 2048) >> 12
    // U = (-11105*R - 21792*G + 32897*B + 2048) >> 12
    // V = ( 32897*R - 27525*G -  5372*B + 2048) >> 12
    // 
    // _mm_madd_epi16̌^Ɏ܂悤ɕό`
    // Y = ( (  7532*B + 22211*G ) + ( 19666*R + 16384*G ) + 2048 ) >> 12
    // U = ( ( 16513*B - 21792*G ) + ( 16384*B - 11105*R ) + 2048 ) >> 12
    // V = ( ( -5372*B - 27525*G ) + ( 16513*R + 16384*R ) + 2048 ) >> 12
    // :          :        :               :       :          :
    // :          :        :               :       :          :
    //                                                
    //             coe0                coe1           coeA
    //               coe2                    coe3
    //               coe4                    coe5
    //
    // BT.709̏ꍇ
    // ̕ϊ
    // y  = ( 13987*R + 47055*G +  4750*B + 2048) >> 12;
    // cb = ( -7539*R - 25359*G + 32896*B + 2048) >> 12;
    // cr = ( 32896*R - 29881*G -  3017*B + 2048) >> 12;
    // 
    // _mm_madd_epi16̌^Ɏ܂悤ɕό`
    // y  = ( (  4750*B + 30671*G ) + ( 13987*R + 16384*G ) + 2048 ) >> 12
    // cb = ( ( 16512*B - 25359*G ) + ( 16384*B -  7539*R ) + 2048 ) >> 12
    // cr = ( ( -3017*B - 29881*G ) + ( 16512*R + 16384*R ) + 2048 ) >> 12
    // :          :        :               :       :          :
    // :          :        :               :       :          :
    //                                                
    //             coe0                coe1           coeA
    //               coe2                    coe3
    //               coe4                    coe5
    // convert_mode
    // 0:BT.601
    // 1:BT.709
    const __m128i coe0 = (convert_mode == 0)
                        ? _mm_setr_epi16(  7532, 22211, 16513, -21792, -5372, -27525,  7532, 22211 )
                        : _mm_setr_epi16(  4750, 30671, 16512, -25359, -3017, -29881,  4750, 30671 );
    const __m128i coe1 = (convert_mode == 0)
                        ? _mm_setr_epi16( 19666, 16384, 16384, -11105, 16513,  16384, 19666, 16384 )
                        : _mm_setr_epi16( 13987, 16384, 16384,  -7539, 16512,  16384, 13987, 16384 );
    const __m128i coe2 = _mm_shuffle_epi32( coe0, _MM_SHUFFLE( 1, 0, 2, 1 ) );
    const __m128i coe3 = _mm_shuffle_epi32( coe1, _MM_SHUFFLE( 1, 0, 2, 1 ) );
    const __m128i coe4 = _mm_shuffle_epi32( coe0, _MM_SHUFFLE( 2, 1, 0, 2 ) );
    const __m128i coe5 = _mm_shuffle_epi32( coe1, _MM_SHUFFLE( 2, 1, 0, 2 ) );
    const __m128i coe6 = coe0;
    const __m128i coe7 = coe1;
    const __m128i coe8 = coe2;
    const __m128i coe9 = coe3;
    const __m128i coe10 = coe4;
    const __m128i coe11 = coe5;
    const __m128i coeA = _mm_setr_epi32( 2048, 2048, 2048, 2048 );

    //#define MY_SET_RGB2YC_0_( R0, G0, B0, R1, G1, B1 ) _mm_setr_epi16( B0, G0, B0, G0, B0, G0, B1, G1 )
    //#define MY_SET_RGB2YC_1_( R0, G0, B0, R1, G1, B1 ) _mm_setr_epi16( R0, G0, B0, R0, R0, R0, R1, G1 )
    //#define MY_SET_RGB2YC_2_( R1, G1, B1, R2, G2, B2 ) _mm_setr_epi16( B1, G1, B1, G1, B2, G2, B2, G2 )
    //#define MY_SET_RGB2YC_3_( R1, G1, B1, R2, G2, B2 ) _mm_setr_epi16( B1, R1, R1, R1, R2, G2, B2, R2 )
    //#define MY_SET_RGB2YC_4_( R2, G2, B2, R3, G3, B3 ) _mm_setr_epi16( B2, G2, B3, G3, B3, G3, B3, G3 )
    //#define MY_SET_RGB2YC_5_( R2, G2, B2, R3, G3, B3 ) _mm_setr_epi16( R2, R2, R3, G3, B3, R3, R3, R3 )
    #define MY_SET_RGB2YC_REGBG_( B0, G0, B1, G1, B2, G2, B3, G3 ) MY_SETR_EPI16( B0, G0, B1, G1, B2, G2, B3, G3 )
    #define MY_SET_RGB2YC_0_( REGBG ) _mm_shuffle_epi32( REGBG, _MM_SHUFFLE( 1, 0, 0, 0 ) )
    #define MY_SET_RGB2YC_2_( REGBG ) _mm_shuffle_epi32( REGBG, _MM_SHUFFLE( 2, 2, 1, 1 ) )
    #define MY_SET_RGB2YC_4_( REGBG ) _mm_shuffle_epi32( REGBG, _MM_SHUFFLE( 3, 3, 3, 2 ) )
    #define MY_SET_RGB2YC_1_( REG0, R0, R1 ) _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( REG0, R0, 0 ), R0, 3 ), R0, 4 ), R0, 5 ), R1, 6 )
    #define MY_SET_RGB2YC_3_( REG2, R1, R2 ) _mm_shufflelo_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( REG2, R1, 1 ), R2, 4 ), R2, 7 ), _MM_SHUFFLE( 1, 1, 1, 0 ) )
    #define MY_SET_RGB2YC_5_( REG4, R2, R3 ) _mm_shufflehi_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( REG4, R2, 0 ), R2, 1 ), R3, 2 ), R3, 5 ), _MM_SHUFFLE( 1, 1, 1, 0 ) )
    #define MY_SET_RGB2YC_6_ MY_SET_RGB2YC_0_
    #define MY_SET_RGB2YC_7_ MY_SET_RGB2YC_1_
    #define MY_SET_RGB2YC_8_ MY_SET_RGB2YC_2_
    #define MY_SET_RGB2YC_9_ MY_SET_RGB2YC_3_
    #define MY_SET_RGB2YC_10_ MY_SET_RGB2YC_4_
    #define MY_SET_RGB2YC_11_ MY_SET_RGB2YC_5_

    for( int y = y_start; y < y_end; y++ )
    {
        PIXEL_YC *__restrict__ ycp2 = (PIXEL_YC *)((BYTE *)ycp + (h-y-1) * line_size);
        const unsigned char *__restrict__ pixelp2 = (unsigned char *)pixelp + y * pixel_line_size;

        int x = 0;

        // o͑̃|C^16byteACgɑB
        // 蔲̂߁ApaddingŒł2byteɑĂ  xȏ̉KvB
        intptr_t padding = (intptr_t)ycp2 & 0xF;
        if( w > 15 && !(padding & 0x1) )
        {
            padding = ((padding >> 1) * 5) & 0x7; // ̂ɕKvȃsNZ

            _mm_prefetch( (BYTE *)pixelp2 + pixel_line_size, _MM_HINT_NTA ); // ̃CvtFb`

            // i1sNZj
            if( padding & 0x1 )
            {
                __m128i xmm0 = _mm_cvtsi32_si128( pixelp2[0] );
                xmm0 = _mm_insert_epi16( xmm0, pixelp2[1], 1 );
                xmm0 = _mm_shuffle_epi32( xmm0, _MM_SHUFFLE( 0, 0, 0, 0 ) );
                __m128i xmm1 = _mm_insert_epi16( xmm0, pixelp2[2], 0 );
                xmm1 = _mm_insert_epi16( xmm1, pixelp2[2], 3 );
                xmm1 = _mm_insert_epi16( xmm1, pixelp2[2], 4 );
                xmm1 = _mm_insert_epi16( xmm1, pixelp2[2], 5 );
                xmm0 = _mm_add_epi32( _mm_madd_epi16( xmm0, coe0 ), _mm_madd_epi16( xmm1, coe1 ) );
                xmm0 = _mm_srai_epi32( _mm_add_epi32( xmm0, coeA ), 12 );
                ycp2->y  = _mm_extract_epi16( xmm0, 0 );
                ycp2->cb = _mm_extract_epi16( xmm0, 2 );
                ycp2->cr = _mm_extract_epi16( xmm0, 4 );
                pixelp2 += 3;
                ycp2++;
                x++;
                padding--;
            }
            // i_mm_stream_si32g߂2sNZj
            for( ; x < padding; x += 2 )
            {
                __m128i xmm0 = _mm_cvtsi32_si128( pixelp2[0] );
                xmm0 = _mm_insert_epi16( xmm0, pixelp2[1], 1 );
                xmm0 = _mm_shuffle_epi32( xmm0, _MM_SHUFFLE( 0, 0, 0, 0 ) );
                __m128i xmm1 = _mm_insert_epi16( xmm0, pixelp2[2], 0 );
                xmm1 = _mm_insert_epi16( xmm1, pixelp2[2], 3 );
                xmm1 = _mm_insert_epi16( xmm1, pixelp2[2], 4 );
                xmm1 = _mm_insert_epi16( xmm1, pixelp2[2], 5 );
                xmm0 = _mm_add_epi32( _mm_madd_epi16( xmm0, coe0 ), _mm_madd_epi16( xmm1, coe1 ) );
                xmm0 = _mm_srai_epi32( _mm_add_epi32( xmm0, coeA ), 12 );

                __m128i xmm2 = _mm_cvtsi32_si128( pixelp2[3] );
                xmm2 = _mm_insert_epi16( xmm2, pixelp2[4], 1 );
                xmm2 = _mm_shuffle_epi32( xmm2, _MM_SHUFFLE( 0, 0, 0, 0 ) );
                __m128i xmm3 = _mm_insert_epi16( xmm2, pixelp2[5], 0 );
                xmm3 = _mm_insert_epi16( xmm3, pixelp2[5], 3 );
                xmm3 = _mm_insert_epi16( xmm3, pixelp2[5], 4 );
                xmm3 = _mm_insert_epi16( xmm3, pixelp2[5], 5 );
                xmm2 = _mm_add_epi32( _mm_madd_epi16( xmm2, coe0 ), _mm_madd_epi16( xmm3, coe1 ) );
                xmm2 = _mm_srai_epi32( _mm_add_epi32( xmm2, coeA ), 12 );

                _mm_stream_si32( (int *)ycp2 + 0, MK_INT( _mm_extract_epi16( xmm0, 0 ), _mm_extract_epi16( xmm0, 2 ) ) );
                _mm_stream_si32( (int *)ycp2 + 1, MK_INT( _mm_extract_epi16( xmm0, 4 ), _mm_extract_epi16( xmm2, 0 ) ) );
                _mm_stream_si32( (int *)ycp2 + 2, MK_INT( _mm_extract_epi16( xmm2, 2 ), _mm_extract_epi16( xmm2, 4 ) ) );

                pixelp2 += 6;
                ycp2 += 2;
            }
            // ACgĂ
            // 8sNZ
            for( ; x < w - 7; x += 8 )
            {
                _mm_prefetch( (BYTE *)&pixelp2[0] + pixel_line_size, _MM_HINT_NTA ); // ̃CvtFb`

                __m128i in0 = MY_SET_RGB2YC_REGBG_( pixelp2[0], pixelp2[1], pixelp2[3], pixelp2[4], pixelp2[6], pixelp2[7], pixelp2[9], pixelp2[10] );
                __m128i xmm0 = MY_SET_RGB2YC_0_( in0 );
                __m128i xmm1 = MY_SET_RGB2YC_1_( xmm0, pixelp2[2], pixelp2[5] );
                __m128i t0 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( _mm_madd_epi16( xmm0, coe0 ), coeA ), _mm_madd_epi16( xmm1, coe1 ) ), 12 );
                __m128i xmm2 = MY_SET_RGB2YC_2_( in0 );
                __m128i xmm3 = MY_SET_RGB2YC_3_( xmm2, pixelp2[5], pixelp2[8] );
                __m128i t1 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( _mm_madd_epi16( xmm2, coe2 ), coeA ), _mm_madd_epi16( xmm3, coe3 ) ), 12 );
                _mm_stream_si128( (__m128i *)ycp2 + 0, _mm_packs_epi32( t0, t1 ) ); // o
                __m128i xmm4 = MY_SET_RGB2YC_4_( in0 );
                __m128i xmm5 = MY_SET_RGB2YC_5_( xmm4, pixelp2[8], pixelp2[11] );
                __m128i t2 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( _mm_madd_epi16( xmm4, coe4 ), coeA ), _mm_madd_epi16( xmm5, coe5 ) ), 12 );

                __m128i in1 = MY_SET_RGB2YC_REGBG_( pixelp2[12], pixelp2[13], pixelp2[15], pixelp2[16], pixelp2[18], pixelp2[19], pixelp2[21], pixelp2[22] );
                __m128i xmm6 = MY_SET_RGB2YC_6_( in1 );
                __m128i xmm7 = MY_SET_RGB2YC_7_( xmm6, pixelp2[14], pixelp2[17] );
                __m128i t3 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( _mm_madd_epi16( xmm6, coe6 ), coeA ), _mm_madd_epi16( xmm7, coe7 ) ), 12 );
                _mm_stream_si128( (__m128i *)ycp2 + 1, _mm_packs_epi32( t2, t3 ) ); // o
                __m128i xmm8 = MY_SET_RGB2YC_8_( in1 );
                __m128i xmm9 = MY_SET_RGB2YC_9_( xmm8, pixelp2[17], pixelp2[20] );
                __m128i t4 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( _mm_madd_epi16( xmm8, coe8 ), coeA ), _mm_madd_epi16( xmm9, coe9 ) ), 12 );
                __m128i xmm10 = MY_SET_RGB2YC_10_( in1 );
                __m128i xmm11 = MY_SET_RGB2YC_11_( xmm10, pixelp2[20], pixelp2[23] );
                __m128i t5 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( _mm_madd_epi16( xmm10, coe10 ), coeA ), _mm_madd_epi16( xmm11, coe11 ) ), 12 );
                _mm_stream_si128( (__m128i *)ycp2 + 2, _mm_packs_epi32( t4, t5 ) ); // o

                pixelp2 += 24;
                ycp2 += 8;
            }
            // ci_mm_stream_si32g߂2sNZj
            for( ; x < w - 1; x += 2 )
            {
                __m128i xmm0 = _mm_cvtsi32_si128( pixelp2[0] );
                xmm0 = _mm_insert_epi16( xmm0, pixelp2[1], 1 );
                xmm0 = _mm_shuffle_epi32( xmm0, _MM_SHUFFLE( 0, 0, 0, 0 ) );
                __m128i xmm1 = _mm_insert_epi16( xmm0, pixelp2[2], 0 );
                xmm1 = _mm_insert_epi16( xmm1, pixelp2[2], 3 );
                xmm1 = _mm_insert_epi16( xmm1, pixelp2[2], 4 );
                xmm1 = _mm_insert_epi16( xmm1, pixelp2[2], 5 );
                xmm0 = _mm_add_epi32( _mm_madd_epi16( xmm0, coe0 ), _mm_madd_epi16( xmm1, coe1 ) );
                xmm0 = _mm_srai_epi32( _mm_add_epi32( xmm0, coeA ), 12 );

                __m128i xmm2 = _mm_cvtsi32_si128( pixelp2[3] );
                xmm2 = _mm_insert_epi16( xmm2, pixelp2[4], 1 );
                xmm2 = _mm_shuffle_epi32( xmm2, _MM_SHUFFLE( 0, 0, 0, 0 ) );
                __m128i xmm3 = _mm_insert_epi16( xmm2, pixelp2[5], 0 );
                xmm3 = _mm_insert_epi16( xmm3, pixelp2[5], 3 );
                xmm3 = _mm_insert_epi16( xmm3, pixelp2[5], 4 );
                xmm3 = _mm_insert_epi16( xmm3, pixelp2[5], 5 );
                xmm2 = _mm_add_epi32( _mm_madd_epi16( xmm2, coe0 ), _mm_madd_epi16( xmm3, coe1 ) );
                xmm2 = _mm_srai_epi32( _mm_add_epi32( xmm2, coeA ), 12 );

                _mm_stream_si32( (int *)ycp2 + 0, MK_INT( _mm_extract_epi16( xmm0, 0 ), _mm_extract_epi16( xmm0, 2 ) ) );
                _mm_stream_si32( (int *)ycp2 + 1, MK_INT( _mm_extract_epi16( xmm0, 4 ), _mm_extract_epi16( xmm2, 0 ) ) );
                _mm_stream_si32( (int *)ycp2 + 2, MK_INT( _mm_extract_epi16( xmm2, 2 ), _mm_extract_epi16( xmm2, 4 ) ) );

                pixelp2 += 6;
                ycp2 += 2;
            }
        }
        else
        {
            // ACgĂȂ
            // i _mm_stream_si128  _mm_storeu_si128 ɒuj
            // 8sNZ
            // 8sNZ
            for( ; x < w - 7; x += 8 )
            {
                _mm_prefetch( (BYTE *)&pixelp2[0] + pixel_line_size, _MM_HINT_NTA ); // ̃CvtFb`

                __m128i in0 = MY_SET_RGB2YC_REGBG_( pixelp2[0], pixelp2[1], pixelp2[3], pixelp2[4], pixelp2[6], pixelp2[7], pixelp2[9], pixelp2[10] );
                __m128i xmm0 = MY_SET_RGB2YC_0_( in0 );
                __m128i xmm1 = MY_SET_RGB2YC_1_( xmm0, pixelp2[2], pixelp2[5] );
                __m128i t0 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( _mm_madd_epi16( xmm0, coe0 ), coeA ), _mm_madd_epi16( xmm1, coe1 ) ), 12 );
                __m128i xmm2 = MY_SET_RGB2YC_2_( in0 );
                __m128i xmm3 = MY_SET_RGB2YC_3_( xmm2, pixelp2[5], pixelp2[8] );
                __m128i t1 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( _mm_madd_epi16( xmm2, coe2 ), coeA ), _mm_madd_epi16( xmm3, coe3 ) ), 12 );
                _mm_storeu_si128( (__m128i *)ycp2 + 0, _mm_packs_epi32( t0, t1 ) ); // o
                __m128i xmm4 = MY_SET_RGB2YC_4_( in0 );
                __m128i xmm5 = MY_SET_RGB2YC_5_( xmm4, pixelp2[8], pixelp2[11] );
                __m128i t2 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( _mm_madd_epi16( xmm4, coe4 ), coeA ), _mm_madd_epi16( xmm5, coe5 ) ), 12 );

                __m128i in1 = MY_SET_RGB2YC_REGBG_( pixelp2[12], pixelp2[13], pixelp2[15], pixelp2[16], pixelp2[18], pixelp2[19], pixelp2[21], pixelp2[22] );
                __m128i xmm6 = MY_SET_RGB2YC_6_( in1 );
                __m128i xmm7 = MY_SET_RGB2YC_7_( xmm6, pixelp2[14], pixelp2[17] );
                __m128i t3 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( _mm_madd_epi16( xmm6, coe6 ), coeA ), _mm_madd_epi16( xmm7, coe7 ) ), 12 );
                _mm_storeu_si128( (__m128i *)ycp2 + 1, _mm_packs_epi32( t2, t3 ) ); // o
                __m128i xmm8 = MY_SET_RGB2YC_8_( in1 );
                __m128i xmm9 = MY_SET_RGB2YC_9_( xmm8, pixelp2[17], pixelp2[20] );
                __m128i t4 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( _mm_madd_epi16( xmm8, coe8 ), coeA ), _mm_madd_epi16( xmm9, coe9 ) ), 12 );
                __m128i xmm10 = MY_SET_RGB2YC_10_( in1 );
                __m128i xmm11 = MY_SET_RGB2YC_11_( xmm10, pixelp2[20], pixelp2[23] );
                __m128i t5 = _mm_srai_epi32( _mm_add_epi32( _mm_add_epi32( _mm_madd_epi16( xmm10, coe10 ), coeA ), _mm_madd_epi16( xmm11, coe11 ) ), 12 );
                _mm_storeu_si128( (__m128i *)ycp2 + 2, _mm_packs_epi32( t4, t5 ) ); // o

                pixelp2 += 24;
                ycp2 += 8;
            }
        }

        // c1sNZ
        for( ; x < w; x++ )
        {
            __m128i xmm0 = _mm_cvtsi32_si128( pixelp2[0] );
            xmm0 = _mm_insert_epi16( xmm0, pixelp2[1], 1 );
            xmm0 = _mm_shuffle_epi32( xmm0, _MM_SHUFFLE( 0, 0, 0, 0 ) );
            __m128i xmm1 = _mm_insert_epi16( xmm0, pixelp2[2], 0 );
            xmm1 = _mm_insert_epi16( xmm1, pixelp2[2], 3 );
            xmm1 = _mm_insert_epi16( xmm1, pixelp2[2], 4 );
            xmm1 = _mm_insert_epi16( xmm1, pixelp2[2], 5 );
            xmm0 = _mm_add_epi32( _mm_madd_epi16( xmm0, coe0 ), _mm_madd_epi16( xmm1, coe1 ) );
            xmm0 = _mm_srai_epi32( _mm_add_epi32( xmm0, coeA ), 12 );
            ycp2->y  = _mm_extract_epi16( xmm0, 0 );
            ycp2->cb = _mm_extract_epi16( xmm0, 2 );
            ycp2->cr = _mm_extract_epi16( xmm0, 4 );
            pixelp2 += 3;
            ycp2 += 1;
        }
    }
}

//---------------------------------------------------------------------
// [Xbh] YC48 -> RGB24
// convert_mode̒lɂYC48̐FԂς
// 0:BT.601
// 1:BT.709
//---------------------------------------------------------------------
void __attribute__((force_align_arg_pointer)) thread_yc2pixel_rgb24( int thread_id, int thread_num, void *param1, void *param2 )
{
    // l[
    const COLOR_PROC_INFO *cpip  = (COLOR_PROC_INFO *)param1;
    const int convert_mode = *(int *)param2; //  0:BT.601  1:BT.709

    // [JϐɃRs[
    const int line_size = cpip->line_size;
    const int w         = cpip->w;
    const int h         = cpip->h;
    PIXEL_YC *ycp       = cpip->ycp;
    DWORD *pixelp       = (DWORD *)cpip->pixelp;

    // Xbhc̃TCY葽璲
    if( thread_num > h ) thread_num = h;
    if( thread_id >= thread_num ) return;

    // Xbh̉摜郉CvZ
    const int y_start = (h *  thread_id     ) / thread_num;
    const int y_end   = (h * (thread_id + 1)) / thread_num;

    // W萔
    const int pixel_line_size = (w*3+3)&(~3L);

    // BT.601̏ꍇ
    // B0 = ( 255*y0 + 452*cb0           + 2048) >> 12
    // G0 = ( 255*y0 -  88*cb0 - 182*cr0 + 2048) >> 12
    // R0 = ( 255*y0           + 358*cr0 + 2048) >> 12
    //
    // ό`
    // B0 = ( (510*y0 + 64*64) + ( 904*cb0 +    0*cr0) ) >> 13
    // G0 = ( (510*y0 + 64*64) + (-176*cb0 + -364*cr0) ) >> 13
    // R0 = ( (510*y0 + 64*64) + (   0*cb0 +  716*cr0) ) >> 13
    // B1 = ( (510*y1 + 64*64) + ( 904*cb1 +    0*cr1) ) >> 13
    //           :       :           :        :
    //           :       :           :        :
    //                                  
    //            coeMA           coe0
    //                                  coe1
    //                                  coe2
    //                                   :
    //
    // BT.709̏ꍇ
    // B0 = ( 255*y0 + 473*cb0           + 2048) >> 12;
    // G0 = ( 255*y0 -  48*cb0 - 120*cr0 + 2048) >> 12;
    // R0 = ( 255*y0           + 401*cr0 + 2048) >> 12;
    //
    // ό`
    // B0 = ( (510*y0 + 64*64) + ( 946*cb0 +    0*cr0) ) >> 13
    // G0 = ( (510*y0 + 64*64) + ( -96*cb0 + -240*cr0) ) >> 13
    // R0 = ( (510*y0 + 64*64) + (   0*cb0 +  802*cr0) ) >> 13
    // B1 = ( (510*y1 + 64*64) + ( 946*cb1 +    0*cr1) ) >> 13
    //           :       :           :        :
    //           :       :           :        :
    //                                  
    //            coeMA           coe0
    //                                  coe1
    //                                  coe2
    //                                   :
    // convert_mode
    // 0:BT.601
    // 1:BT.709
    const __m128i coe0 = (convert_mode == 0)
                        ? _mm_setr_epi16( 904, 0, -176, -364, 0, 716, 904, 0 )
                        : _mm_setr_epi16( 946, 0,  -96, -240, 0, 802, 946, 0 );
    const __m128i coe1 = _mm_shuffle_epi32( coe0, _MM_SHUFFLE( 1, 0, 2, 1 ) );
    const __m128i coe2 = _mm_shuffle_epi32( coe0, _MM_SHUFFLE( 2, 1, 0, 2 ) );
    const __m128i coe3 = coe0;
    const __m128i coe4 = coe1;
    const __m128i coe5 = coe2;
    const __m128i coe6 = coe0;
    const __m128i coe7 = coe1;
    const __m128i coe8 = coe2;
    const __m128i coe9 = coe0;
    const __m128i coe10 = coe1;
    const __m128i coe11 = coe2;
    const __m128i coeMA = _mm_setr_epi16( 510, 64, 510, 64, 510, 64, 510, 64 );

    //#define MY_SET_YC2RGB_Y0_( P0, P1 ) _mm_setr_epi16( P0.y, 64, P0.y, 64, P0.y, 64, P1.y, 64 )
    //#define MY_SET_YC2RGB_Y1_( P1, P2 ) _mm_setr_epi16( P1.y, 64, P1.y, 64, P2.y, 64, P2.y, 64 )
    //#define MY_SET_YC2RGB_Y2_( P2, P3 ) _mm_setr_epi16( P2.y, 64, P3.y, 64, P3.y, 64, P3.y, 64 )

    #define MY_SET_YC2RGB_REGY_( P0, P1, P2, P3 ) _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( coeMA, P0.y, 0 ), P1.y, 2 ), P2.y, 4 ), P3.y, 6 )
    #define MY_SET_YC2RGB_Y0_( REGY ) _mm_shuffle_epi32( REGY, _MM_SHUFFLE( 1, 0, 0, 0 ) )
    #define MY_SET_YC2RGB_Y1_( REGY ) _mm_shuffle_epi32( REGY, _MM_SHUFFLE( 2, 2, 1, 1 ) )
    #define MY_SET_YC2RGB_Y2_( REGY ) _mm_shuffle_epi32( REGY, _MM_SHUFFLE( 3, 3, 3, 2 ) )
    #define MY_SET_YC2RGB_Y3_ MY_SET_YC2RGB_Y0_
    #define MY_SET_YC2RGB_Y4_ MY_SET_YC2RGB_Y1_
    #define MY_SET_YC2RGB_Y5_ MY_SET_YC2RGB_Y2_
    #define MY_SET_YC2RGB_Y6_ MY_SET_YC2RGB_Y0_
    #define MY_SET_YC2RGB_Y7_ MY_SET_YC2RGB_Y1_
    #define MY_SET_YC2RGB_Y8_ MY_SET_YC2RGB_Y2_
    #define MY_SET_YC2RGB_Y9_ MY_SET_YC2RGB_Y0_
    #define MY_SET_YC2RGB_Y10_ MY_SET_YC2RGB_Y1_
    #define MY_SET_YC2RGB_Y11_ MY_SET_YC2RGB_Y2_

    //#define MY_SET_YC2RGB_C0_( P0, P1 ) _mm_setr_epi16( P0.cb, P0.cr, P0.cb, P0.cr, P0.cb, P0.cr, P1.cb, P1.cr )
    //#define MY_SET_YC2RGB_C1_( P1, P2 ) _mm_setr_epi16( P1.cb, P1.cr, P1.cb, P1.cr, P2.cb, P2.cr, P2.cb, P2.cr )
    //#define MY_SET_YC2RGB_C2_( P2, P3 ) _mm_setr_epi16( P2.cb, P2.cr, P3.cb, P3.cr, P3.cb, P3.cr, P3.cb, P3.cr )

    #define MY_SET_YC2RGB_REGC_( P0, P1, P2, P3 ) MY_SETR_EPI16( P0.cb, P0.cr, P1.cb, P1.cr, P2.cb, P2.cr, P3.cb, P3.cr )
    #define MY_SET_YC2RGB_C0_( REGC ) _mm_shuffle_epi32( REGC, _MM_SHUFFLE( 1, 0, 0, 0 ) )
    #define MY_SET_YC2RGB_C1_( REGC ) _mm_shuffle_epi32( REGC, _MM_SHUFFLE( 2, 2, 1, 1 ) )
    #define MY_SET_YC2RGB_C2_( REGC ) _mm_shuffle_epi32( REGC, _MM_SHUFFLE( 3, 3, 3, 2 ) )
    #define MY_SET_YC2RGB_C3_ MY_SET_YC2RGB_C0_
    #define MY_SET_YC2RGB_C4_ MY_SET_YC2RGB_C1_
    #define MY_SET_YC2RGB_C5_ MY_SET_YC2RGB_C2_
    #define MY_SET_YC2RGB_C6_ MY_SET_YC2RGB_C0_
    #define MY_SET_YC2RGB_C7_ MY_SET_YC2RGB_C1_
    #define MY_SET_YC2RGB_C8_ MY_SET_YC2RGB_C2_
    #define MY_SET_YC2RGB_C9_ MY_SET_YC2RGB_C0_
    #define MY_SET_YC2RGB_C10_ MY_SET_YC2RGB_C1_
    #define MY_SET_YC2RGB_C11_ MY_SET_YC2RGB_C2_

    #define _YC2RGB_CALC( REGY, REGC, COE_MADD ) _mm_srai_epi32( _mm_add_epi32( _mm_madd_epi16( REGY, coeMA ), _mm_madd_epi16( REGC, COE_MADD ) ), 13 )

    for( int y = y_start; y < y_end; y++ )
    {
        const PIXEL_YC *__restrict__ ycp2 = (PIXEL_YC *)((BYTE *)ycp + y * line_size);
        unsigned char *__restrict__ pixelp2 = (unsigned char *)pixelp + (h-y-1) * pixel_line_size;
        int x = 0;

        // o͑̃|C^16byteACgɑB
        // 蔲̂߁Axȏ̉KvB
        if( w > 63 )
        {
            intptr_t padding = (intptr_t)pixelp2 & 0xF;
            padding = (padding * 5) & 0xF; // ̂ɕKvȃsNZ

           _mm_prefetch( (BYTE *)ycp2 + line_size, _MM_HINT_NTA ); // ̃CvtFb`

            // 1sNZ
            for( ; x < padding; x++ )
            {
                __m128i Y = _mm_shuffle_epi32( _mm_madd_epi16( _mm_insert_epi16( coeMA, ycp2->y, 0 ), coeMA ), _MM_SHUFFLE( 0, 0, 0, 0 ) );
                __m128i C = _mm_shuffle_epi32( _mm_insert_epi16( _mm_cvtsi32_si128( ycp2->cb ), ycp2->cr, 1 ), _MM_SHUFFLE( 0, 0, 0, 0 ) );
                __m128i t = _mm_srai_epi32( _mm_add_epi32( Y, _mm_madd_epi16( C, coe0 ) ), 13 );
                __m128i xmm = _mm_packus_epi16( _mm_packs_epi32( t, _mm_setzero_si128() ), _mm_setzero_si128() );
                pixelp2[0] = (unsigned short)_mm_extract_epi16( xmm, 0 ) & 0xff;
                pixelp2[1] = (unsigned short)_mm_extract_epi16( xmm, 0 ) >> 8;
                pixelp2[2] = (unsigned short)_mm_extract_epi16( xmm, 1 ) & 0xff;

                ycp2++;
                pixelp2 += 3;
            }
            // ACgĂ
            // 16sNZ
            for( ; x < w - 15; x += 16 )
            {
                _mm_prefetch( (BYTE *)&ycp2[0] + line_size, _MM_HINT_NTA ); // ̃CvtFb`
                _mm_prefetch( (BYTE *)&ycp2[8] + line_size, _MM_HINT_NTA ); // ̃CvtFb`

                __m128i inY = MY_SET_YC2RGB_REGY_( ycp2[0], ycp2[1], ycp2[2], ycp2[3] );
                __m128i inC = MY_SET_YC2RGB_REGC_( ycp2[0], ycp2[1], ycp2[2], ycp2[3] );
                __m128i xmm0 = _mm_packs_epi32
                    (
                        _YC2RGB_CALC( MY_SET_YC2RGB_Y0_( inY ), MY_SET_YC2RGB_C0_( inC ), coe0 ),
                        _YC2RGB_CALC( MY_SET_YC2RGB_Y1_( inY ), MY_SET_YC2RGB_C1_( inC ), coe1 )
                    );
                __m128i t2 = _YC2RGB_CALC( MY_SET_YC2RGB_Y2_( inY ), MY_SET_YC2RGB_C2_( inC ), coe2 );

                inY = MY_SET_YC2RGB_REGY_( ycp2[4], ycp2[5], ycp2[6], ycp2[7] );
                inC = MY_SET_YC2RGB_REGC_( ycp2[4], ycp2[5], ycp2[6], ycp2[7] );
                __m128i xmm1 = _mm_packs_epi32
                    (
                        t2,
                        _YC2RGB_CALC( MY_SET_YC2RGB_Y3_( inY ), MY_SET_YC2RGB_C3_( inC ), coe3 )
                    );
                _mm_stream_si128( (__m128i *)&pixelp2[0], _mm_packus_epi16( xmm0, xmm1 ) ); // o
                __m128i xmm2 = _mm_packs_epi32
                    (
                        _YC2RGB_CALC( MY_SET_YC2RGB_Y4_( inY ), MY_SET_YC2RGB_C4_( inC ), coe4 ),
                        _YC2RGB_CALC( MY_SET_YC2RGB_Y5_( inY ), MY_SET_YC2RGB_C5_( inC ), coe5 )
                    );

                inY = MY_SET_YC2RGB_REGY_( ycp2[8], ycp2[9], ycp2[10], ycp2[11] );
                inC = MY_SET_YC2RGB_REGC_( ycp2[8], ycp2[9], ycp2[10], ycp2[11] );
                 __m128i xmm3 = _mm_packs_epi32
                    (
                        _YC2RGB_CALC( MY_SET_YC2RGB_Y6_( inY ), MY_SET_YC2RGB_C6_( inC ), coe6 ),
                        _YC2RGB_CALC( MY_SET_YC2RGB_Y7_( inY ), MY_SET_YC2RGB_C7_( inC ), coe7 )
                    );
                _mm_stream_si128( (__m128i *)&pixelp2[16], _mm_packus_epi16( xmm2, xmm3 ) );  // o
                __m128i t8 = _YC2RGB_CALC( MY_SET_YC2RGB_Y8_( inY ), MY_SET_YC2RGB_C8_( inC ), coe8 );

                inY = MY_SET_YC2RGB_REGY_( ycp2[12], ycp2[13], ycp2[14], ycp2[15] );
                inC = MY_SET_YC2RGB_REGC_( ycp2[12], ycp2[13], ycp2[14], ycp2[15] );
                __m128i xmm4 = _mm_packs_epi32
                    (
                        t8,
                        _YC2RGB_CALC( MY_SET_YC2RGB_Y9_( inY ), MY_SET_YC2RGB_C9_( inC ), coe9 )
                    );
                __m128i xmm5 = _mm_packs_epi32
                    (
                        _YC2RGB_CALC( MY_SET_YC2RGB_Y10_( inY ), MY_SET_YC2RGB_C10_( inC ), coe10 ),
                        _YC2RGB_CALC( MY_SET_YC2RGB_Y11_( inY ), MY_SET_YC2RGB_C11_( inC ), coe11 )
                    );
                _mm_stream_si128( (__m128i *)&pixelp2[32], _mm_packus_epi16( xmm4, xmm5 ) ); // o

                ycp2 += 16;
                pixelp2 += 48;
            }
        }
        else
        {
            // ACgĂȂ
            // i _mm_stream_si128  _mm_storeu_si128 ɒuj
            // 16sNZ
            for( ; x < w - 15; x += 16 )
            {
                _mm_prefetch( (BYTE *)&ycp2[0] + line_size, _MM_HINT_NTA ); // ̃CvtFb`
                _mm_prefetch( (BYTE *)&ycp2[8] + line_size, _MM_HINT_NTA ); // ̃CvtFb`

                __m128i inY = MY_SET_YC2RGB_REGY_( ycp2[0], ycp2[1], ycp2[2], ycp2[3] );
                __m128i inC = MY_SET_YC2RGB_REGC_( ycp2[0], ycp2[1], ycp2[2], ycp2[3] );
                __m128i xmm0 = _mm_packs_epi32
                    (
                        _YC2RGB_CALC( MY_SET_YC2RGB_Y0_( inY ), MY_SET_YC2RGB_C0_( inC ), coe0 ),
                        _YC2RGB_CALC( MY_SET_YC2RGB_Y1_( inY ), MY_SET_YC2RGB_C1_( inC ), coe1)
                    );
                __m128i t2 = _YC2RGB_CALC( MY_SET_YC2RGB_Y2_( inY ), MY_SET_YC2RGB_C2_( inC ), coe2 );

                inY = MY_SET_YC2RGB_REGY_( ycp2[4], ycp2[5], ycp2[6], ycp2[7] );
                inC = MY_SET_YC2RGB_REGC_( ycp2[4], ycp2[5], ycp2[6], ycp2[7] );
                __m128i xmm1 = _mm_packs_epi32
                    (
                        t2,
                        _YC2RGB_CALC( MY_SET_YC2RGB_Y3_( inY ), MY_SET_YC2RGB_C3_( inC ), coe3 )
                    );
                _mm_storeu_si128( (__m128i *)&pixelp2[0], _mm_packus_epi16( xmm0, xmm1 ) ); // o
                __m128i xmm2 = _mm_packs_epi32
                    (
                        _YC2RGB_CALC( MY_SET_YC2RGB_Y4_( inY ), MY_SET_YC2RGB_C4_( inC ), coe4 ),
                        _YC2RGB_CALC( MY_SET_YC2RGB_Y5_( inY ), MY_SET_YC2RGB_C5_( inC ), coe5 )
                    );

                inY = MY_SET_YC2RGB_REGY_( ycp2[8], ycp2[9], ycp2[10], ycp2[11] );
                inC = MY_SET_YC2RGB_REGC_( ycp2[8], ycp2[9], ycp2[10], ycp2[11] );
                 __m128i xmm3 = _mm_packs_epi32
                    (
                        _YC2RGB_CALC( MY_SET_YC2RGB_Y6_( inY ), MY_SET_YC2RGB_C6_( inC ), coe6 ),
                        _YC2RGB_CALC( MY_SET_YC2RGB_Y7_( inY ), MY_SET_YC2RGB_C7_( inC ), coe7 )
                    );
                _mm_storeu_si128( (__m128i *)&pixelp2[16], _mm_packus_epi16( xmm2, xmm3 ) );  // o
                __m128i t8 = _YC2RGB_CALC( MY_SET_YC2RGB_Y8_( inY ), MY_SET_YC2RGB_C8_( inC ), coe8 );

                inY = MY_SET_YC2RGB_REGY_( ycp2[12], ycp2[13], ycp2[14], ycp2[15] );
                inC = MY_SET_YC2RGB_REGC_( ycp2[12], ycp2[13], ycp2[14], ycp2[15] );
                __m128i xmm4 = _mm_packs_epi32
                    (
                        t8,
                        _YC2RGB_CALC( MY_SET_YC2RGB_Y9_( inY ), MY_SET_YC2RGB_C9_( inC ), coe9 )
                    );
                __m128i xmm5 = _mm_packs_epi32
                    (
                        _YC2RGB_CALC( MY_SET_YC2RGB_Y10_( inY ), MY_SET_YC2RGB_C10_( inC ), coe10 ),
                        _YC2RGB_CALC( MY_SET_YC2RGB_Y11_( inY ), MY_SET_YC2RGB_C11_( inC ), coe11 )
                    );
                _mm_storeu_si128( (__m128i *)&pixelp2[32], _mm_packus_epi16( xmm4, xmm5 ) ); // o

                ycp2 += 16;
                pixelp2 += 48;
            }
        }

        // c1sNZ
        for( ; x < w; x++ )
        {
            __m128i Y = _mm_shuffle_epi32( _mm_madd_epi16( _mm_insert_epi16( coeMA, ycp2->y, 0 ), coeMA ), _MM_SHUFFLE( 0, 0, 0, 0 ) );
            __m128i C = _mm_shuffle_epi32( _mm_insert_epi16( _mm_cvtsi32_si128( ycp2->cb ), ycp2->cr, 1 ), _MM_SHUFFLE( 0, 0, 0, 0 ) );
            __m128i t = _mm_srai_epi32( _mm_add_epi32( Y, _mm_madd_epi16( C, coe0 ) ), 13 );
            __m128i xmm = _mm_packus_epi16( _mm_packs_epi32( t, _mm_setzero_si128() ), _mm_setzero_si128() );
            pixelp2[0] = (unsigned short)_mm_extract_epi16( xmm, 0 ) & 0xff;
            pixelp2[1] = (unsigned short)_mm_extract_epi16( xmm, 0 ) >> 8;
            pixelp2[2] = (unsigned short)_mm_extract_epi16( xmm, 1 ) & 0xff;

            ycp2++;
            pixelp2 += 3;
        }
    }
}
